searchData={"items":[{"type":"module","title":"Geo","doc":"A collection of GIS functions.","ref":"Geo.html"},{"type":"type","title":"Geo.endian/0","doc":"Endianess (byte-order) of the WKB/EWKB representation.\n\n  * `:ndr` - little-endian\n  * `:xdr` - big-endian","ref":"Geo.html#t:endian/0"},{"type":"type","title":"Geo.geometry/0","doc":"","ref":"Geo.html#t:geometry/0"},{"type":"module","title":"Geo.GeometryCollection","doc":"Defines the GeometryCollection struct.","ref":"Geo.GeometryCollection.html"},{"type":"type","title":"Geo.GeometryCollection.t/0","doc":"","ref":"Geo.GeometryCollection.html#t:t/0"},{"type":"module","title":"Geo.JSON","doc":"Converts Geo structs to and from a map representing GeoJSON.\n\nYou are responsible to encoding and decoding of JSON. This is so\nthat you can use any JSON parser you want as well as making it\nso that you can use the resulting GeoJSON structure as a property\nin larger JSON structures.","ref":"Geo.JSON.html"},{"type":"module","title":"Examples - Geo.JSON","doc":"# Using Jason as the JSON parser for these examples\n\n    iex> json = \"{ \\\"type\\\": \\\"Point\\\", \\\"coordinates\\\": [100.0, 0.0] }\"\n    ...> json |> Jason.decode!() |> Geo.JSON.decode!()\n    %Geo.Point{coordinates: {100.0, 0.0}, srid: nil}\n\n    iex> geom = %Geo.Point{coordinates: {100.0, 0.0}, srid: nil}\n    ...> Jason.encode!(geom)\n    \"{\\\"coordinates\\\":[100.0,0.0],\\\"type\\\":\\\"Point\\\"}\"\n\n    iex> geom = %Geo.Point{coordinates: {100.0, 0.0}, srid: nil}\n    ...> Geo.JSON.encode!(geom)\n    %{\"type\" => \"Point\", \"coordinates\" => [100.0, 0.0]}","ref":"Geo.JSON.html#module-examples"},{"type":"function","title":"Geo.JSON.decode/1","doc":"Takes a map representing GeoJSON and returns a Geometry.","ref":"Geo.JSON.html#decode/1"},{"type":"function","title":"Geo.JSON.decode!/1","doc":"Takes a map representing GeoJSON and returns a Geometry.","ref":"Geo.JSON.html#decode!/1"},{"type":"function","title":"Geo.JSON.encode/1","doc":"Takes a Geometry and returns a map representing the GeoJSON.","ref":"Geo.JSON.html#encode/1"},{"type":"function","title":"Geo.JSON.encode/2","doc":"","ref":"Geo.JSON.html#encode/2"},{"type":"function","title":"Geo.JSON.encode!/1","doc":"Takes a Geometry and returns a map representing the GeoJSON.","ref":"Geo.JSON.html#encode!/1"},{"type":"function","title":"Geo.JSON.encode!/2","doc":"","ref":"Geo.JSON.html#encode!/2"},{"type":"module","title":"Geo.LineString","doc":"Defines the LineString struct.","ref":"Geo.LineString.html"},{"type":"type","title":"Geo.LineString.t/0","doc":"","ref":"Geo.LineString.html#t:t/0"},{"type":"module","title":"Geo.LineStringZ","doc":"Defines the LineStringZ struct.","ref":"Geo.LineStringZ.html"},{"type":"type","title":"Geo.LineStringZ.t/0","doc":"","ref":"Geo.LineStringZ.html#t:t/0"},{"type":"module","title":"Geo.LineStringZM","doc":"Defines the LineStringZM struct.","ref":"Geo.LineStringZM.html"},{"type":"type","title":"Geo.LineStringZM.t/0","doc":"","ref":"Geo.LineStringZM.html#t:t/0"},{"type":"module","title":"Geo.MultiLineString","doc":"Defines the MultiLineString struct.","ref":"Geo.MultiLineString.html"},{"type":"type","title":"Geo.MultiLineString.t/0","doc":"","ref":"Geo.MultiLineString.html#t:t/0"},{"type":"module","title":"Geo.MultiLineStringZ","doc":"Defines the MultiLineStringZ struct.","ref":"Geo.MultiLineStringZ.html"},{"type":"type","title":"Geo.MultiLineStringZ.t/0","doc":"","ref":"Geo.MultiLineStringZ.html#t:t/0"},{"type":"module","title":"Geo.MultiPoint","doc":"Defines the MultiPoint struct.","ref":"Geo.MultiPoint.html"},{"type":"type","title":"Geo.MultiPoint.t/0","doc":"","ref":"Geo.MultiPoint.html#t:t/0"},{"type":"module","title":"Geo.MultiPointZ","doc":"Defines the MultiPointZ struct.","ref":"Geo.MultiPointZ.html"},{"type":"type","title":"Geo.MultiPointZ.t/0","doc":"","ref":"Geo.MultiPointZ.html#t:t/0"},{"type":"module","title":"Geo.MultiPolygon","doc":"Defines the MultiPolygon struct.","ref":"Geo.MultiPolygon.html"},{"type":"type","title":"Geo.MultiPolygon.t/0","doc":"","ref":"Geo.MultiPolygon.html#t:t/0"},{"type":"module","title":"Geo.MultiPolygonZ","doc":"Defines the MultiPolygonZ struct.","ref":"Geo.MultiPolygonZ.html"},{"type":"type","title":"Geo.MultiPolygonZ.t/0","doc":"","ref":"Geo.MultiPolygonZ.html#t:t/0"},{"type":"module","title":"Geo.Point","doc":"Defines the Point struct.","ref":"Geo.Point.html"},{"type":"type","title":"Geo.Point.latitude/0","doc":"","ref":"Geo.Point.html#t:latitude/0"},{"type":"type","title":"Geo.Point.longitude/0","doc":"","ref":"Geo.Point.html#t:longitude/0"},{"type":"type","title":"Geo.Point.t/0","doc":"","ref":"Geo.Point.html#t:t/0"},{"type":"module","title":"Geo.PointM","doc":"Defines the PointM struct.","ref":"Geo.PointM.html"},{"type":"type","title":"Geo.PointM.t/0","doc":"","ref":"Geo.PointM.html#t:t/0"},{"type":"module","title":"Geo.PointZ","doc":"Defines the PointZ struct.","ref":"Geo.PointZ.html"},{"type":"type","title":"Geo.PointZ.t/0","doc":"","ref":"Geo.PointZ.html#t:t/0"},{"type":"module","title":"Geo.PointZM","doc":"Defines the PointZM struct.","ref":"Geo.PointZM.html"},{"type":"type","title":"Geo.PointZM.t/0","doc":"","ref":"Geo.PointZM.html#t:t/0"},{"type":"module","title":"Geo.Polygon","doc":"Defines the Polygon struct.","ref":"Geo.Polygon.html"},{"type":"type","title":"Geo.Polygon.t/0","doc":"","ref":"Geo.Polygon.html#t:t/0"},{"type":"module","title":"Geo.PolygonZ","doc":"Defines the Polygon struct.","ref":"Geo.PolygonZ.html"},{"type":"type","title":"Geo.PolygonZ.t/0","doc":"","ref":"Geo.PolygonZ.html#t:t/0"},{"type":"module","title":"Geo.WKB","doc":"Converts to and from WKB and EWKB.\n\nIt supports WKB both as base-16 encoded strings or as binaries.","ref":"Geo.WKB.html"},{"type":"module","title":"Examples - Geo.WKB","doc":"iex> {:ok, point} = Geo.WKB.decode(\"0101000000000000000000F03F000000000000F03F\")\n    Geo.Point[coordinates: {1, 1}, srid: nil]\n\n    iex> Geo.WKT.encode!(point)\n    \"POINT(1 1)\"\n\n    iex> point = Geo.WKB.decode!(\"0101000020E61000009EFB613A637B4240CF2C0950D3735EC0\")\n    Geo.Point[coordinates: {36.9639657, -121.8097725}, srid: 4326]","ref":"Geo.WKB.html#module-examples"},{"type":"function","title":"Geo.WKB.decode/1","doc":"Takes a WKB, either as a base-16 encoded string or a binary, and returns a Geometry.","ref":"Geo.WKB.html#decode/1"},{"type":"function","title":"Geo.WKB.decode!/1","doc":"Takes a WKB, either as a base-16 encoded string or a binary, and returns a Geometry.","ref":"Geo.WKB.html#decode!/1"},{"type":"function","title":"Geo.WKB.encode/2","doc":"Takes a Geometry and returns a base-16 encoded WKB string.\n\nThe endian decides what the byte order will be.","ref":"Geo.WKB.html#encode/2"},{"type":"function","title":"Geo.WKB.encode!/2","doc":"Takes a Geometry and returns a base-16 encoded WKB string.\n\nThe endian decides what the byte order will be.","ref":"Geo.WKB.html#encode!/2"},{"type":"function","title":"Geo.WKB.encode_to_iodata/2","doc":"Takes a Geometry and returns WKB as iodata (a sequence of bytes).\n\nThe endian decides what the byte order will be.","ref":"Geo.WKB.html#encode_to_iodata/2"},{"type":"module","title":"Geo.WKT","doc":"Converts to and from WKT and EWKT","ref":"Geo.WKT.html"},{"type":"module","title":"Examples - Geo.WKT","doc":"iex> {:ok, point} = Geo.WKT.decode(\"POINT(30 -90)\")\n    Geo.Point[coordinates: {30, -90}, srid: nil]\n\n    iex> Geo.WKT.encode!(point)\n    \"POINT(30 -90)\"\n\n    iex> point = Geo.WKT.decode!(\"SRID=4326;POINT(30 -90)\")\n    Geo.Point[coordinates: {30, -90}, srid: 4326]","ref":"Geo.WKT.html#module-examples"},{"type":"function","title":"Geo.WKT.decode/1","doc":"Takes a WKT string and returns a Geo.geometry struct or list of Geo.geometry.","ref":"Geo.WKT.html#decode/1"},{"type":"function","title":"Geo.WKT.decode!/1","doc":"Takes a WKT string and returns a Geo.geometry struct or list of Geo.geometry.","ref":"Geo.WKT.html#decode!/1"},{"type":"function","title":"Geo.WKT.encode/1","doc":"Takes a Geometry and returns a WKT string.","ref":"Geo.WKT.html#encode/1"},{"type":"function","title":"Geo.WKT.encode!/1","doc":"Takes a Geometry and returns a WKT string.","ref":"Geo.WKT.html#encode!/1"},{"type":"exception","title":"Geo.JSON.Decoder.DecodeError","doc":"","ref":"Geo.JSON.Decoder.DecodeError.html"},{"type":"type","title":"Geo.JSON.Decoder.DecodeError.t/0","doc":"","ref":"Geo.JSON.Decoder.DecodeError.html#t:t/0"},{"type":"exception","title":"Geo.JSON.Encoder.EncodeError","doc":"","ref":"Geo.JSON.Encoder.EncodeError.html"},{"type":"type","title":"Geo.JSON.Encoder.EncodeError.t/0","doc":"","ref":"Geo.JSON.Encoder.EncodeError.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v3.6.0 — 2023-10-19 - Changelog","doc":"As of v3.6.0, `geo` (like [`geo_postgis`](https://github.com/felt/geo_postgis)) is being maintained by the Felt team. As a company building a geospatial product on Elixir, with a track record of [supporting open source software](https://felt.com/open-source), we're excited for the future of the project.\n\n#","ref":"changelog.html#v3-6-0-2023-10-19"},{"type":"extras","title":"New features - Changelog","doc":"* [Add support for empty point](https://github.com/felt/geo/pull/172) by new contributor @bolek\n* [Add support for LineStringZM](https://github.com/felt/geo/pull/171) by new contributor @kanatohodets\n* [Support decoding MultiLineStringZ](https://github.com/felt/geo/pull/179) by new contributor @caspg\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Misc. changes - Changelog","doc":"- Fix compile warnings ([#186](https://github.com/felt/geo/pull/186) by @s3cur3)\n- Docs improvements ([#177](https://github.com/felt/geo/pull/177) by new contributor @ghecho, [#182](https://github.com/felt/geo/pull/182) by @s3cur3)\n- Dependency updates: `ex_doc` ([#185](https://github.com/felt/geo/pull/185)), `jason` ([#183](https://github.com/felt/geo/pull/183)), `stream_data` ([#184](https://github.com/felt/geo/pull/184))\n\n**Full Changelog**: https://github.com/felt/geo/compare/v3.5.1...v3.6.0","ref":"changelog.html#misc-changes"},{"type":"extras","title":"v3.5.1 - 2023-06-07 - Changelog","doc":"- Fix\n  - [Fix Application.get_env and use Bitwise warnings](https://github.com/felt/geo/pull/180)","ref":"changelog.html#v3-5-1-2023-06-07"},{"type":"extras","title":"v3.5 - 2023-06-05 - Changelog","doc":"- Enhancement\n  - [Support null feature geometries](https://github.com/felt/geo/pull/176)","ref":"changelog.html#v3-5-2023-06-05"},{"type":"extras","title":"v3.4.3 - 2021-12-15 - Changelog","doc":"- Fix\n  - [Handle MultiLineString with empty coordinates](https://github.com/felt/geo/pull/164)\n  - [Clarify whether functions in Geo.WKB accept or return base16 or bytes](https://github.com/felt/geo/pull/166)","ref":"changelog.html#v3-4-3-2021-12-15"},{"type":"extras","title":"v3.4.2 - 2021-04-11 - Changelog","doc":"- Fix\n  - [Do not accept iodata for decoding](https://github.com/felt/geo/pull/158)","ref":"changelog.html#v3-4-2-2021-04-11"},{"type":"extras","title":"v3.4.1 - 2021-04-10 - Changelog","doc":"- Fix\n  - [Update Specs](https://github.com/felt/geo/pull/157)","ref":"changelog.html#v3-4-1-2021-04-10"},{"type":"extras","title":"v3.4.0 - 2021-04-09 - Changelog","doc":"- Add\n  - `Geo.WKB.encode_to_iodata`\n\n- Enhancements\n  - The implementation of encoding and decoding WKBs has been updated to use iodata instead of binaries, improving overall performance.\n  - `Geo.WKB.decode!` and `Geo.WKB.decode` can now take iodata in addition to binary data","ref":"changelog.html#v3-4-0-2021-04-09"},{"type":"extras","title":"v3.3.8 - 2021-04-02 - Changelog","doc":"- Fix\n  - [Misc doc changes](https://github.com/felt/geo/pull/153)","ref":"changelog.html#v3-3-8-2021-04-02"},{"type":"extras","title":"v3.3.7 - 2020-11-20 - Changelog","doc":"- Fix\n  - [Make Jason optional](https://github.com/felt/geo/pull/149)","ref":"changelog.html#v3-3-7-2020-11-20"},{"type":"extras","title":"v3.3.6 - 2020-11-05 - Changelog","doc":"- Enhancement\n  - [Replace Poison with Jason for JSON encoding in tests](https://github.com/felt/geo/pull/141)\n  - [Add JSON decoding support for LineStringZ](https://github.com/felt/geo/pull/147)","ref":"changelog.html#v3-3-6-2020-11-05"},{"type":"extras","title":"v3.3.5 - 2020-08-26 - Changelog","doc":"- Fixed\n  - Typespec on Point","ref":"changelog.html#v3-3-5-2020-08-26"},{"type":"extras","title":"v3.3.4 - 2020-08-07 - Changelog","doc":"- Fixed\n  - [Update typespec to make Point easier to use](https://github.com/felt/geo/pull/140)","ref":"changelog.html#v3-3-4-2020-08-07"},{"type":"extras","title":"v3.3.3 - 2019-12-13 - Changelog","doc":"- Fixed\n  - [Add missing MultiPointZ in list of geometry types](https://github.com/felt/geo/pull/122)\n  - [Improve docs around Geo.endian type](https://github.com/felt/geo/pull/123)","ref":"changelog.html#v3-3-3-2019-12-13"},{"type":"extras","title":"v3.3.2 - 2019-08-26 - Changelog","doc":"- Fixed\n  - Some optimizations based on benchmarking","ref":"changelog.html#v3-3-2-2019-08-26"},{"type":"extras","title":"v3.3.1 - 2019-08-26 - Changelog","doc":"- Fixed\n  - Bugs found while property testing","ref":"changelog.html#v3-3-1-2019-08-26"},{"type":"extras","title":"v3.3.0 - 2019-08-20 - Changelog","doc":"- Added\n  - [Updated Type Specs](https://github.com/felt/geo/pull/116)\n  - [Allow to disable String.Chars implementation for Geo objects](https://github.com/felt/geo/pull/110)","ref":"changelog.html#v3-3-0-2019-08-20"},{"type":"extras","title":"v3.2.0 - 2019-07-23 - Changelog","doc":"- Added\n  - [3D versions of the various datatypes](https://github.com/felt/geo/pull/111)","ref":"changelog.html#v3-2-0-2019-07-23"},{"type":"extras","title":"v3.1.0 - 2019-02-08 - Changelog","doc":"- Fixed\n  - [Optimise reverse_byte_order/1](https://github.com/felt/geo/pull/107)\n\n- Added\n  - [Support WKB empty multipolygons](https://github.com/felt/geo/pull/100)\n  - [Add PointZ support to Geo.Json](https://github.com/felt/geo/pull/99)","ref":"changelog.html#v3-1-0-2019-02-08"},{"type":"extras","title":"v3.0.0 - 2018-04-14 - Changelog","doc":"- Add\n\n  - `Geo.WKT.encode!`\n  - `Geo.WKT.decode!`\n  - `Geo.WKB.encode!`\n  - `Geo.WKB.decode!`\n  - `Geo.JSON.encode!`\n  - `Geo.JSON.decode!`\n\n- Enhancement\n\n  - Geometry struct now have a `properties` field. This is used to convert GeoJSON properties\n\n- Breaking\n\n  - `Geo.WKT.encode` now returns either `{:ok, binary}` or `{:error, exception}`\n  - `Geo.WKT.decode` now returns either `{:ok, geometry}` or `{:error, exception}`\n  - `Geo.WKB.encode` now returns either `{:ok, binary}` or `{:error, exception}`\n  - `Geo.WKB.decode` now returns either `{:ok, geometry}` or `{:error, exception}`\n  - `Geo.JSON.encode` now returns either `{:ok, map}` or `{:error, exception}`\n  - `Geo.JSON.decode` now returns either `{:ok, geom}` or `{:error, exception}`\n  - All Ecto.Type behaviour implementations were removed. This may not effect too many people, but it was moved to the [geo_postgis](https://github.com/felt/geo_postgis) package","ref":"changelog.html#v3-0-0-2018-04-14"},{"type":"extras","title":"v2.1.0 - 2018-01-28 - Changelog","doc":"- Fix\n  - Make stricter patterns for casts functions so that error pattern is used when types are wrong\n  - [Change handling of EPSG/SRID to match standard](https://github.com/felt/geo/pull/79)\n  - [Fix String.strip() deprecations in Elixir 1.5+](https://github.com/felt/geo/pull/78)","ref":"changelog.html#v2-1-0-2018-01-28"},{"type":"extras","title":"v2.0.0 - 2017-07-15 - Changelog","doc":"- Breaking\n  - Split out PostGIS functionality into its own library, [geo_postgis](https://github.com/felt/geo_postgis)","ref":"changelog.html#v2-0-0-2017-07-15"},{"type":"extras","title":"v1.5.0 - 2017-06-10 - Changelog","doc":"- Enhancement\n  - [Add `st_distancesphere/2`](https://github.com/felt/geo/pull/69)","ref":"changelog.html#v1-5-0-2017-06-10"},{"type":"extras","title":"v1.4.1 - 2017-02-17 - Changelog","doc":"- Fixes\n  - [Updated ecto related documentation on Geo module](https://github.com/felt/geo/pull/66)","ref":"changelog.html#v1-4-1-2017-02-17"},{"type":"extras","title":"v1.4.0 - 2017-02-17 - Changelog","doc":"- Enhancements\n  - [Add `st_dwithin_in_meters\\3`](https://github.com/felt/geo/pull/64)\n  - [Make sure an srid of 0 does not show srid in WKT](https://github.com/felt/geo/pull/63)\n  - [Add types PointZ, PointM and PointZM](https://github.com/felt/geo/pull/56)","ref":"changelog.html#v1-4-0-2017-02-17"},{"type":"extras","title":"v1.3.1 - 2016-12-24 - Changelog","doc":"- Enhancements\n  - Relax Poison dependency requirement","ref":"changelog.html#v1-3-1-2016-12-24"},{"type":"extras","title":"v1.3.0 - 2016-12-19 - Changelog","doc":"- Enhancements\n\n  - [Support new Postgrex 0.13 Extension API](https://github.com/felt/geo/pull/53)\n\n- Breaking\n  - Now only supports Postgrex 0.13+\n  - Now only supports Ecto 2.1+","ref":"changelog.html#v1-3-0-2016-12-19"},{"type":"extras","title":"v1.2.1 - 2016-11-04 - Changelog","doc":"- Enhancements\n  - [add st_transform](https://github.com/felt/geo/pull/51)","ref":"changelog.html#v1-2-1-2016-11-04"},{"type":"extras","title":"v1.2.0 - 2016-10-26 - Changelog","doc":"- Enhancements\n  - [add st_distance_sphere](https://github.com/felt/geo/pull/49)","ref":"changelog.html#v1-2-0-2016-10-26"},{"type":"extras","title":"v1.1.2 - 2016-09-14 - Changelog","doc":"- Bug Fixes\n  - WKBs that are GeometryCollections with one element should now properly decode","ref":"changelog.html#v1-1-2-2016-09-14"},{"type":"extras","title":"v1.1.1 - 2016-07-19 - Changelog","doc":"- Enhancements\n  - Added `Geo.JSON.EncodeError` and `Geo.JSON.DecodeError` thrown whenever `Geo.JSON.encode` or `Geo.JSON.decode` are given invalid data","ref":"changelog.html#v1-1-1-2016-07-19"},{"type":"extras","title":"v1.1.0 - 2016-07-09 - Changelog","doc":"- Enhancements\n  - Add Geo.Geometry custom Ecto type to allow multiple geometries in a single field","ref":"changelog.html#v1-1-0-2016-07-09"},{"type":"extras","title":"v1.0.6 - 2016-06-26 - Changelog","doc":"- Enhancements\n  - Fixed warnings that appeared in Elixir 1.3","ref":"changelog.html#v1-0-6-2016-06-26"},{"type":"extras","title":"v1.0.5 - 2016-06-22 - Changelog","doc":"- Enhancements\n  - Update to allow use with Ecto 2.0","ref":"changelog.html#v1-0-5-2016-06-22"},{"type":"extras","title":"v1.0.4 - 2016-05-23 - Changelog","doc":"- Enhancements\n  - Ecto.Type: matching on geojson properties so that Ecto.DataType can be used by users","ref":"changelog.html#v1-0-4-2016-05-23"},{"type":"extras","title":"v1.0.3 - 2016-05-14 - Changelog","doc":"- Enhancements\n  - Updated dependencies to allow for using ecto 2.0 release candidate versions","ref":"changelog.html#v1-0-3-2016-05-14"},{"type":"extras","title":"v1.0.2 - 2016-04-03 - Changelog","doc":"- Enhancements\n  - Updated dependencies to allow for using ecto 2.0 beta versions","ref":"changelog.html#v1-0-2-2016-04-03"},{"type":"extras","title":"v1.0.1 - 2016-01-31 - Changelog","doc":"- Enhancements\n  - Updated Postgrex and Poison optional dependencies","ref":"changelog.html#v1-0-1-2016-01-31"},{"type":"extras","title":"v1.0.0 - 2015-11-29 - Changelog","doc":"","ref":"changelog.html#v1-0-0-2015-11-29"},{"type":"extras","title":"v0.18.0 - 2015-11-11 - Changelog","doc":"- Enhancements\n  - Made Postgrex, Ecto, and Poison optional dependencies","ref":"changelog.html#v0-18-0-2015-11-11"},{"type":"extras","title":"v0.17.0 - 2015-10-13 - Changelog","doc":"- Breaking\n  - Geo.JSON.encode and Geo.JSON.decode now do not do any JSON parsing at all and\n    instead work on a map representation of GeoJSON. All JSON encoding and decoding\n    must be done before or after calling those functions.","ref":"changelog.html#v0-17-0-2015-10-13"},{"type":"extras","title":"v0.16.1 - 2015-08-27 - Changelog","doc":"- Enhancements\n  - Made Postgrex a required dependency","ref":"changelog.html#v0-16-1-2015-08-27"},{"type":"extras","title":"v0.16.0 - 2015-08-27 - Changelog","doc":"- Enhancements\n  - Updated to Ecto 1.0","ref":"changelog.html#v0-16-0-2015-08-27"},{"type":"extras","title":"v0.15.2 - 2015-08-10 - Changelog","doc":"- Enhancements\n  - Added an `opts` parameter to `Geo.JSON.encode` to allow for skipping JSON encoding","ref":"changelog.html#v0-15-2-2015-08-10"},{"type":"extras","title":"v0.15.1 - 2015-07-27 - Changelog","doc":"- Enhancements\n  - Fixed st_dwithin macro","ref":"changelog.html#v0-15-1-2015-07-27"},{"type":"extras","title":"v0.15.0 - 2015-07-24 - Changelog","doc":"- Enhancements\n  - Updated cast function on structs to handle maps and strings\n  - Now reading the srid from geo json","ref":"changelog.html#v0-15-0-2015-07-24"},{"type":"extras","title":"v0.14.0 - 2015-07-19 - Changelog","doc":"- Enhancements\n  - Basic Support for Geography datatype","ref":"changelog.html#v0-14-0-2015-07-19"},{"type":"extras","title":"v0.13.0 - 2015-06-08 - Changelog","doc":"- Enhancements\n\n  - Added PostGIS function macros for use in Ecto Queries. Currently only the OpenGIS ones\n\n- Breaking\n  - `Geo.PostGIS` is now `Geo.PostGIS.Extension`\n  - Changed from Jazz to Poison for JSON encoding and decoding","ref":"changelog.html#v0-13-0-2015-06-08"},{"type":"extras","title":"v0.12.0 - 2015-03-08 - Changelog","doc":"- Enhancements\n  - Geo.PostGIS is now a Postgrex Extension\n  - Updated to work with latest version of Ecto","ref":"changelog.html#v0-12-0-2015-03-08"},{"type":"extras","title":"v0.11.2 - 2015-02-13 - Changelog","doc":"- Bug fixes\n  - Correctly decoding WKB strings that caused invalid geometries to be produced when there is one element in a multi geometry","ref":"changelog.html#v0-11-2-2015-02-13"},{"type":"extras","title":"v0.11.1 - 2015-02-12 - Changelog","doc":"- Bug fixes\n  - Fixed bug when decoding multi geometry wkb with one geometry inside would cause a crash","ref":"changelog.html#v0-11-1-2015-02-12"},{"type":"extras","title":"v0.11.0 - 2015-02-03 - Changelog","doc":"- Enhancements\n\n  - Created structs for the supported geospatial types (Point, LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon, GeometryCollection)\n  - GeoJson module will encode the srid as a crs property if an srid exists\n\n- Backwards incompatible changes\n  - Removed the Geometry struct. Use one of the geometry type structs instead\n  - The base coordinate pairs are now tuples ({0,0} instead of [0,0])","ref":"changelog.html#v0-11-0-2015-02-03"},{"type":"extras","title":"Geo","doc":"# Geo\n\n[![Build Status](https://github.com/felt/geo/actions/workflows/elixir-build-and-test.yml/badge.svg?branch=master)](https://github.com/felt/geo/actions/workflows/elixir-build-and-test.yml)\n[![Module Version](https://img.shields.io/hexpm/v/geo.svg)](https://hex.pm/packages/geo)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/geo/)\n[![Total Download](https://img.shields.io/hexpm/dt/geo.svg)](https://hex.pm/packages/geo)\n[![License](https://img.shields.io/hexpm/l/geo.svg)](https://github.com/felt/geo/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/felt/geo.svg)](https://github.com/felt/geo/commits/master)\n\nA collection of GIS functions. Handles conversions to and from well-known text (WKT), well-known binary (WKB), and GeoJSON for the following geometries:\n\n* Point\n* PointZ\n* PointM\n* PointZM\n* LineString\n* LineStringZ\n* LineStringZM\n* Polygon\n* PolygonZ\n* MultiPoint\n* MultiPointZ\n* MuliLineString\n* MuliLineStringZ\n* MultiPolygon\n* MultiPolygonZ\n* GeometryCollection\n\n_Note_: If you are looking for the Postgrex PostGIS extension, check out [geo_postgis](https://github.com/felt/geo_postgis).\n\n_Note_: If you are looking to do geospatial calculations in memory with Geo's structs, check out [topo](https://github.com/pkinney/topo).\n\n```elixir\ndefp deps do\n  [\n    {:geo, \"~> 3.6\"}\n  ]\nend\n```","ref":"readme.html"},{"type":"extras","title":"Examples - Geo","doc":"Encode and decode WKT and EWKT:\n\n```elixir\niex(1)> {:ok, point} = Geo.WKT.decode(\"POINT(30 -90)\")\n%Geo.Point{ coordinates: {30, -90}, srid: nil}\n\niex(2)> Geo.WKT.encode!(point)\n\"POINT(30 -90)\"\n\niex(3)> point = Geo.WKT.decode!(\"SRID=4326;POINT(30 -90)\")\n%Geo.Point{coordinates: {30, -90}, srid: 4326}\n```\n\nEncode and decode WKB and EWKB:\n\n```elixir\niex(1)> {:ok, point} = Geo.WKB.decode(\"0101000000000000000000F03F000000000000F03F\")\n%Geo.Point{ coordinates: {1.0, 1.0}, srid: nil }\n\niex(2)> Geo.WKB.encode!(point)\n\"00000000013FF00000000000003FF0000000000000\"\n\niex(3)> point = Geo.WKB.decode!(\"0101000020E61000009EFB613A637B4240CF2C0950D3735EC0\")\n%Geo.Point{ coordinates: {36.9639657, -121.8097725}, srid: 4326 }\n\niex(4)> Geo.WKB.encode!(point)\n\"0020000001000010E640427B633A61FB9EC05E73D350092CCF\"\n```\n\nEncode and decode GeoJSON:\n\nGeo only encodes and decodes maps shaped as GeoJSON. JSON encoding and decoding must\nbe done before and after.\n\n```elixir\n# Examples using Jason as the JSON parser\n\niex(1)> Geo.JSON.encode(point)\n{:ok, %{ \"type\" => \"Point\", \"coordinates\" => [100.0, 0.0] }}\n\niex(2)> point = Jason.decode!(\"{\\\"type\\\": \\\"Point\\\", \\\"coordinates\\\": [100.0, 0.0] }\") |> Geo.JSON.decode\n%Geo.Point{ coordinates: {100.0, 0.0}, srid: nil }\n\niex(3)> Geo.JSON.encode!(point) |> Jason.encode!\n\"{\\\"coordinates\\\":[100.0,0.0],\\\"type\\\":\\\"Point\\\"}\"\n```","ref":"readme.html#examples"},{"type":"extras","title":"Copyright and License - Geo","doc":"Copyright (c) 2014 Bryan Joseph\n\nReleased under the MIT License, which can be found in the repository in [`LICENSE`](https://github.com/felt/geo/blob/master/LICENSE.md).","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}